"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = SpacesList;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactVirtualized = require("react-virtualized");

({}); // @related-file react-virtualized/styles.css

var _reactComponentSpaceItem = _interopRequireDefault(require("@ciscospark/react-component-space-item"));

var _reactComponentSpinner = _interopRequireDefault(require("@ciscospark/react-component-spinner"));

var propTypes = {
  activeSpaceId: _propTypes.default.string,
  hasCalling: _propTypes.default.bool,
  isLoadingMore: _propTypes.default.bool,
  onCallClick: _propTypes.default.func,
  onClick: _propTypes.default.func,
  spaces: _propTypes.default.arrayOf(_propTypes.default.shape({
    avatarUrl: _propTypes.default.string,
    activityText: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]),
    callStartTime: _propTypes.default.number,
    id: _propTypes.default.string,
    isDecrypting: _propTypes.default.bool,
    isUnread: _propTypes.default.bool,
    lastActivityTime: _propTypes.default.string,
    name: _propTypes.default.string,
    teamColor: _propTypes.default.string,
    teamName: _propTypes.default.string,
    type: _propTypes.default.string
  }))
};
var defaultProps = {
  activeSpaceId: '',
  hasCalling: false,
  isLoadingMore: false,
  onCallClick: function onCallClick() {},
  onClick: function onClick() {},
  spaces: []
};

function SpacesList(_ref) {
  var activeSpaceId = _ref.activeSpaceId,
      hasCalling = _ref.hasCalling,
      isLoadingMore = _ref.isLoadingMore,
      onCallClick = _ref.onCallClick,
      onClick = _ref.onClick,
      spaces = _ref.spaces;

  function rowRenderer(options) {
    var key = options.key,
        index = options.index,
        style = options.style;

    if (index >= spaces.length) {
      return _react.default.createElement("div", {
        key: key,
        style: style
      }, _react.default.createElement(_reactComponentSpinner.default, {
        bright: true
      }));
    }

    var space = spaces[index];
    return _react.default.createElement("div", {
      className: (0, _classnames.default)("ciscospark-spaces-list-item-".concat(index)),
      key: key,
      style: style
    }, _react.default.createElement(_reactComponentSpaceItem.default, (0, _extends2.default)({
      active: space.id === activeSpaceId,
      hasCalling: hasCalling,
      key: key,
      onCallClick: onCallClick,
      onClick: onClick
    }, space)));
  }

  var rowCount = isLoadingMore ? spaces.length + 1 : spaces.length;
  return _react.default.createElement("div", {
    style: {
      height: '100%',
      width: '100%'
    }
  }, _react.default.createElement(_reactVirtualized.AutoSizer, null, function (_ref2) {
    var height = _ref2.height,
        width = _ref2.width;
    return _react.default.createElement(_reactVirtualized.List, {
      className: "ciscospark-spaces-list",
      height: height,
      rowCount: rowCount,
      rowHeight: 70,
      rowRenderer: rowRenderer,
      width: width
    });
  }));
}

SpacesList.propTypes = propTypes;
SpacesList.defaultProps = defaultProps;